package com.photo.wallpaper.category;

import android.app.Application;
import android.content.Context;
import android.graphics.Typeface;
import android.util.Log;

import com.anythink.core.api.ATSDK;
import com.anythink.core.api.NetTrafficeCallback;
import com.photo.wallpaper.category.ad.AdManager;
import com.photo.wallpaper.category.utils.CommonHelper;
import com.photo.wallpaper.category.utils.ParseData;
import com.photo.wallpaper.category.bean.DataBaseHelper;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class MyApp extends Application {
    public static Context mAppContext;

    public static String TAG = "-------MyApp---------";
    public static Typeface defaultFont;


    private String animasName = "Animals.json";
    private String exName = "Experimental.json";
    private String filmName = "Film.json";
    private String natureName = "Nature.json";
    private String pattName = "Patterns.json";
    private String streetName = "Street.json";
    private String travelName = "Travel.json";
    private String wallpaperName = "Featured.json";
    private ExecutorService executor;
    private static List<String> CategoryNames = new ArrayList<>();
    private int i = 0;

    @Override
    public void onCreate() {
        super.onCreate();
        mAppContext = this;
        defaultFont = Typeface.createFromAsset(getAssets(), "custfont.ttf");
        initAd();
        DataBaseHelper.init(this);
        executor = Executors.newFixedThreadPool(8);
        String[] names = {wallpaperName, animasName, exName, filmName, natureName, pattName, streetName, travelName};

        try {
            for (String name : names) {
                InputStream open = getAssets().open(name);
                String covertStr = CommonHelper.getCovertStr(open);
                if (!covertStr.isEmpty()) {
                    String realName = name.substring(0, name.indexOf("."));
                    CategoryNames.add(realName);
                    executor.execute(new Runnable() {
                        @Override
                        public void run() {
                            i++;
                            Log.d(MyApp.TAG, "------------111");
                            ParseData.INSTANCE.getData(covertStr, realName);
//                            if (i == 8) {
//                                executor.shutdown();
//                                Log.d(MyWallpaper.TAG, "------------data complete");
//                            }

                        }
                    });
                }
            }


        } catch (IOException e) {
            throw new RuntimeException(e);
        }


    }

    public static List<String> getCategoryNames() {
        return CategoryNames;
    }


    private void initAd() {
        String APPId = "h67cff355ac03b";
        String AppKey = "a51ae85bffe9009f8e1129e5576b7cac4";
        ATSDK.checkIsEuTraffic(this, new NetTrafficeCallback() {

            @Override
            public void onResultCallback(boolean isEU) {
                if (isEU && ATSDK.getGDPRDataLevel(MyApp.mAppContext) == ATSDK.UNKNOWN) {
                    ATSDK.showGdprAuth(MyApp.mAppContext);
                }

            }

            @Override
            public void onErrorCallback(String errorMsg) {

            }
        });
        ATSDK.init(this, APPId, AppKey);
        //测试工具
//        ATDebuggerUITest.showDebuggerUI(this,debug_Key);
        AdManager.loadAllAd();

    }
}
